<template>
  <TransitionGroup :name="transitionAnimation">
    <template :key="'segments'" v-for="(segment, index) in segments">
      <FactSegment
        v-if="segment.layout === 'standard'"
        v-show="index === currentIndex && index < segments.length - 1"
        :first="index == 0"
        :key="'standard-' + index"
        :image-url="segment.imageUrl"
        :imageElement="segment.imageElement"
        :imageAlignment="segment.imageAlignment"
        :title="segment.title"
        :text="segment.text"
        :random-color="randomColor"
        :image-attribution="segment.imageAttribution"
        :narration-time="narrationTime"
        :playbackSpeed="playbackSpeed"
        :kenBurns="kenBurns"
        :logoElement="logoElement"
      />
      <SmallFactSegment
        v-else
        v-show="index === currentIndex && index < segments.length - 1"
        :first="index == 0"
        :key="'small-' + index"
        :image-url="segment.imageUrl"
        :imageElement="segment.imageElement"
        :imageAlignment="segment.imageAlignment"
        :title="segment.title"
        :text="segment.text"
        :random-color="randomColor"
        :image-attribution="segment.imageAttribution"
        :narration-time="narrationTime"
        :playbackSpeed="playbackSpeed"
        :kenBurns="kenBurns"
        :logoElement="logoElement"
      />
    </template>
  </TransitionGroup>
  <EndCard
    v-if="currentIndex === segments.length - 1"
    v-bind:key="`end`"
    :playbackSpeed="playbackSpeed"
  />
</template>

<script lang="ts" setup>
import FactSegment from '../components/FactSegment.vue';
import SmallFactSegment from '../components/SmallFactSegment.vue';
import EndCard from '../components/EndCard.vue';

import { FactSegmentData } from '../types';
defineProps<{
  segments: FactSegmentData[];
  currentIndex: number;
  randomColor: string;
  narrationTime: number;
  playbackSpeed: number;
  kenBurns: string;
  transitionAnimation: string;
  logoElement: HTMLImageElement | undefined;
}>();
</script>
